<?php

//SMFChess Admin Source File
//ChessAdmin.php

// If the file isn't called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');

// Load the language file
loadLanguage('ChessAdmin');
// Check if they're allowed here
isAllowedTo('chess_admin');

//Where objects go to be stored
function ChessAdmin()
{ 
	global $context, $txt, $settings, $scripturl, $modSettings, $sourcedir;
	
	adminIndex('chess_admin');
	if (isset($_GET['save']))
	{
		// SMFChess Settings
		$newSettings['SMFChess_piece'] = $_POST['SMFChess_piece'];
		$newSettings['SMFChess_dark'] = $_POST['SMFChess_dark'];
		$newSettings['SMFChess_light'] = $_POST['SMFChess_light'];
		$newSettings['SMFChess_size'] = (int) $_POST['SMFChess_size'];
		
		$newSettings['SMFChess_cremind'] = (int) $_POST['SMFChess_cremind'];
		$newSettings['SMFChess_cremind'] = $newSettings['SMFChess_cremind'] > 0 ? $newSettings['SMFChess_cremind'] : 1 ;
		$newSettings['SMFChess_ccancel'] = (int) $_POST['SMFChess_ccancel'];
		$newSettings['SMFChess_ccancel'] = $newSettings['SMFChess_ccancel'] > 0 ? $newSettings['SMFChess_ccancel'] : 1 ;
		
		$newSettings['SMFChess_cjoinlimit'] = (int) $_POST['SMFChess_cjoinlimit'];
		$newSettings['SMFChess_cjoinlimit'] = $newSettings['SMFChess_cjoinlimit'] > 0 ? $newSettings['SMFChess_cjoinlimit'] : 1 ;
		$newSettings['SMFChess_cquicklimit'] = (int) $_POST['SMFChess_cquicklimit'];
		$newSettings['SMFChess_cquicklimit'] = $newSettings['SMFChess_cquicklimit'] > 0 ? $newSettings['SMFChess_cquicklimit'] : 1 ;
		
		$newSettings['SMFChess_border'] = $_POST['SMFChess_border'];
		$newSettings['SMFChess_text'] = $_POST['SMFChess_text'];
		$newSettings['SMFChess_highlight'] = $_POST['SMFChess_highlight'];
		$newSettings['SMFChess_effect'] = (int) $_POST['SMFChess_effect'];
		$newSettings['SMFChess_bar'] = $_POST['SMFChess_bar'];
		$newSettings['SMFChess_update'] = (int) $_POST['SMFChess_update'];
		$newSettings['SMFChess_update'] = $newSettings['SMFChess_update'] < 1 ? 1 : $newSettings['SMFChess_update'];
		$newSettings['SMFChess_timeout'] = (int) $_POST['SMFChess_timeout'];
		$newSettings['SMFChess_timeout'] = $newSettings['SMFChess_timeout'] < 1 ? 1 : $newSettings['SMFChess_timeout'];
		$newSettings['SMFChess_news'] = $_POST['SMFChess_news'];

		// SMFChessChat Settings
		if(!isset($_POST['SMFChessChat_enabled']))
			$_POST['SMFChessChat_enabled'] = false;
		if(!isset($_POST['SMFChessChat_log']))
			$_POST['SMFChessChat_log'] = 0;
		$newSettings['SMFChessChat_enabled'] = $_POST['SMFChessChat_enabled'];
		$newSettings['SMFChessChat_update'] = (int) $_POST['SMFChessChat_update'];
		$newSettings['SMFChessChat_update'] = $newSettings['SMFChessChat_update'] < 1 ? 1 : $newSettings['SMFChessChat_update'];
		$newSettings['SMFChessChat_timeout'] = (int) $_POST['SMFChessChat_timeout'];
		$newSettings['SMFChessChat_timeout'] = $newSettings['SMFChessChat_timeout'] < 1 ? 1 : $newSettings['SMFChessChat_timeout'];
		$newSettings['SMFChessChat_see'] = (int) $_POST['SMFChessChat_see'];
		$newSettings['SMFChessChat_who'] = (int) $_POST['SMFChessChat_who'];
		$newSettings['SMFChessChat_log'] = (int) $_POST['SMFChessChat_log'];
		
		// Save all these settings
		updateSettings($newSettings);

	}
	
	$context['html_headers'] .= '
			<link rel="stylesheet" type="text/css" href="'.$settings['default_theme_url'].'/SMFChess/colorpicker/colorPicker.css">
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/lib/prototype.js"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/src/scriptaculous.js?load=effects,slider,builder,dragdrop"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/colorpicker/yahoo.color.js"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/colorpicker/colorPicker.js"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/SMFChess_admin_settings.js"></script>
			<link rel="stylesheet" type="text/css" href="'.$settings['default_theme_url'].'/SMFChess/SMFChess_settings.css" />
			<script type="text/javascript">
			<!--
			var	cur_session_id = "'.$context['session_id'].'";
			var actualPrevImageSize = 0;
			var currentPiece = "'.$modSettings['SMFChess_piece'].'";
			var startcolor = "'.$modSettings['SMFChess_highlight'].'";
			var endcolor = "'.$modSettings['SMFChess_light'].'";
			var temp2 = \'\';
			var smfchessUrl = \''.$settings['default_theme_url'].'/SMFChess/\';
			//-->
			</script>';
	
	$context['SMFChess']['customBar'] = '<a href="'.$scripturl . '?action=theme;th='.(file_exists($settings['theme_dir'].'/ChessCustom.template.php')?$settings['theme_id']:1).';sesc='.$context['session_id'].';sa=edit;filename=ChessCustom.template.php">'.$txt['SMFChess_a_s']['v_menu_custom2'].'</a>'; 
	
	$context['SMFChess']['pieces'] = getPieces('');
	
	$context['page_title'] = $txt['SMFChess_admin'].' '.$txt['settings'];
	loadTemplate('ChessAdmin');
}

// Recursive function to retrieve avatar files
function getPieces($directory)
{
	global $context, $txt, $modSettings, $boarddir, $settings, $boardurl;
	
	$piece_dir =  $settings['default_theme_dir'].'/SMFChess/pieces';
	
	$result = array();

	// Open the directory..
	$dir = dir($piece_dir . (!empty($directory) ? '/' : '') . $directory);
	$dirs = array();

	if (!$dir)
		return array();

	while ($line = $dir->read())
	{
		if (in_array($line, array('.', '..', 'blank.gif', 'index.php')))
			continue;

		if (is_dir($piece_dir . '/' . $directory . (!empty($directory) ? '/' : '') . $line))
			$dirs[] = $line;
	}
	$dir->close();

	// Sort the results...
	natcasesort($dirs);
	
	if(!isset($options['SMFChess_piece']))
		$options['SMFChess_piece'] = '';
	
	foreach ($dirs as $line)
	{
		$result[] = array(
			'filename' => htmlspecialchars($line),
			'checked' => $modSettings['SMFChess_piece'] == htmlspecialchars($line),
			'name' => htmlspecialchars(str_replace('_', ' ', $line)),
			'is_dir' => true
		);
	}

	return $result;
}

//Chess Maintenance
function ChessMaintenance()
{ 
	global $context, $txt, $settings, $scripturl, $db_prefix, $txt;

	adminIndex('chess_admin_maint');
	$context['SMFChess']['result'] = array();
		
	$context['page_title'] = $txt['SMFChess_admin'].' '.$txt[501];
	loadTemplate('ChessAdmin');
	$context['sub_template'] = 'maintenance';
	
	$context['html_headers'] .= '
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/lib/prototype.js"></script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/scriptaculous/src/scriptaculous.js"></script>
			<link rel="stylesheet" type="text/css" href="'.$settings['default_theme_url'].'/SMFChess/SMFChess_admin_maint.css">
			<script type="text/javascript">
			<!--
			var cur_session_id = "'.$context['session_id'].'";
			//-->
			</script>
			<script type="text/javascript" src="'.$settings['default_theme_url'].'/SMFChess/SMFChess_admin_maint.js"></script>';
	
	if(isset($_GET['do'])){
		
		//Recount Chess Results
		if($_GET['do'] == 'recountresults'){
			checkSession('get');
			$eloOnly = isset($_GET['eloonly']);
			
			//Reset Stats
			db_query("UPDATE {$db_prefix}members
				SET ".($eloOnly ? "" : "chess_w = 0, chess_d = 0, chess_l = 0, chess_s = 0, ")."chess_elo = 1000
				", __FILE__, __LINE__);	
			
			
			$request = db_query("
				SELECT chess.id_chess, chess.white, chess.black, chess.status, chess.extra
				FROM {$db_prefix}chess AS chess
				WHERE status > 2", __FILE__, __LINE__);
			
			$context['SMFChess']['result']['SMFChess_maint_recount'] = mysql_num_rows($request);
			
			while ($row = mysql_fetch_assoc($request)){
				
				$request2 = db_query("
					SELECT mw.chess_elo AS whiteElo, mw.chess_s AS whiteStreak,
					mb.chess_elo AS blackElo, mb.chess_s AS blackStreak
					FROM {$db_prefix}chess AS chess
					JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
					JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
					WHERE chess.id_chess = {$row['id_chess']}
					ORDER BY chess.updated ASC
					LIMIT 1", __FILE__, __LINE__);
				list($row['whiteElo'], $row['whiteStreak'], $row['blackElo'], $row['blackStreak']) = mysql_fetch_row($request2);
				mysql_free_result($request2);
				
				// Calc W
				if($row['whiteElo'] < 1200){
					$eloK = 32;
					$bonus = ($row['extra'] == $row['white']) ? 400 : +400 ;
				}elseif($row['whiteElo'] < 1400){
					$eloK = 16;
					$bonus = ($row['extra'] == $row['white']) ? 100 : +100 ;
				}elseif($row['whiteElo'] < 1600){
					$eloK = 16;
					$bonus = 0 ;
				}else{
					$eloK = 8;
					$bonus = 0 ;
				}

				$result = ($row['extra'] == $row['white']) ? 1 : (($row['status'] == 4) ? .5 : 0 ) ;
				
				$newElo = 1 / (1 + (pow(10,((($row['blackElo'] + $bonus) - $row['whiteElo'])/400))));
				
				$newElo = (int) ($row['whiteElo'] + ($eloK * ($result - $newElo)));
				
				$newElo = ($newElo < 1000) ? 1000 : $newElo ;
				
				if(($row['whiteElo'] < 1100) && ($row['whiteElo'] > $newElo))
					$newElo = $row['whiteElo'] ;
				$newArray = array('chess_elo' => $newElo);
				if(!$eloOnly){
					if($result == 1)
							$newArray += array('chess_w' => '+', 'chess_s' => (($row['whiteStreak'] >= 0) ? $row['whiteStreak'] + 1 : 1 ));
					elseif($result == .5)
						$newArray += array('chess_d' => '+', 'chess_s' => 0);
					else
						$newArray += array('chess_l' => '+', 'chess_s' => (($row['whiteStreak'] <= 0) ? $row['whiteStreak'] - 1 : -1 ));
				}
				updateMemberData($row['white'], $newArray);

				// Calc B
				if($row['blackElo'] < 1200){
					$eloK = 32;
					$bonus = ($row['extra'] == $row['black']) ? 400 : -400 ;
				}elseif($row['blackElo'] < 1400){
					$eloK = 16;
					$bonus = ($row['extra'] == $row['black']) ? 100 : -100 ;
				}elseif($row['blackElo'] < 1600){
					$eloK = 16;
					$bonus = 0 ;
				}else{
					$eloK = 8;
					$bonus = 0 ;
				}
				
				$result = ($row['extra'] == $row['black']) ? 1 : (($row['status'] == 4) ? .5 : 0 ) ;

				$newElo = 1 / (1 + (pow(10,((($row['whiteElo'] + $bonus) - $row['blackElo'])/400))));
				$newElo = (int) ($row['blackElo'] + ($eloK * ($result - $newElo)));
				
				$newElo = ($newElo < 1000) ? 1000 : $newElo ;
				
				if(($row['blackElo'] < 1100) && ($row['blackElo'] > $newElo))
					$newElo = $row['blackElo'] ;
				
				$newArray = array('chess_elo' => $newElo);
				if(!$eloOnly){
					if($result == 1)
						$newArray += array('chess_w' => '+', 'chess_s' => (($row['blackStreak'] >= 0) ? $row['blackStreak'] + 1 : 1 ));
					elseif($result == .5)
						$newArray += array('chess_d' => '+', 'chess_s' => 0);
					else
						$newArray += array('chess_l' => '+', 'chess_s' => (($row['blackStreak'] <= 0) ? $row['blackStreak'] - 1 : -1 ));
				}
				
				updateMemberData($row['black'], $newArray);				
			}
			mysql_free_result($request);

		// Fix any errors that may have cropped up
		}elseif($_GET['do'] == 'fixerrors'){
			checkSession('get');

			// Check if extra is ok for finished games
			$affected_total = 0;
			db_query("UPDATE {$db_prefix}chess
						SET extra=white
						WHERE status < 3 AND boarddata LIKE '%w%'", __FILE__, __LINE__);
			$affected_total += db_affected_rows();
			db_query("UPDATE {$db_prefix}chess
						SET extra=black
						WHERE status < 3 AND boarddata NOT LIKE '%w%'", __FILE__, __LINE__);
			$affected_total += db_affected_rows();
			
			$context['SMFChess']['result']['SMFChess_maint_result_fixcurrent'] = $affected_total;
				
			// Check if extra is ok for finished games
			$affected_total = 0;
			db_query("UPDATE {$db_prefix}chess
						SET extra=white
						WHERE status=3 AND boarddata NOT LIKE '%w%'", __FILE__, __LINE__);
			$affected_total += db_affected_rows();
			db_query("UPDATE {$db_prefix}chess
						SET extra=black
						WHERE status=3 AND boarddata LIKE '%w%'", __FILE__, __LINE__);
			$affected_total += db_affected_rows();
			
			$context['SMFChess']['result']['SMFChess_maint_result_fixfininished'] = $affected_total;

			// Make sure extra is 0 is status = 4
			$affected_total = 0;
			db_query("UPDATE {$db_prefix}chess
						SET extra=0
						WHERE status=4", __FILE__, __LINE__);
			$affected_total += db_affected_rows();
			
			$context['SMFChess']['result']['SMFChess_maint_result_fixdraw'] = $affected_total;
						
			// Remove any games if a member id bring back a null value
			$affected_total = 0;
		
			$result = db_query("
				SELECT chess.id_chess
				FROM {$db_prefix}chess AS chess
					LEFT JOIN {$db_prefix}members as mw ON (mw.ID_MEMBER = chess.white)
					LEFT JOIN {$db_prefix}members as mb ON (mb.ID_MEMBER = chess.black)
				WHERE (mw.ID_MEMBER IS NULL OR mb.ID_MEMBER IS NULL) AND chess.white != 0
				GROUP BY chess.id_chess", __FILE__, __LINE__);
			$boards = array();
			while ($row = mysql_fetch_assoc($result))
				$boards[] = $row['id_chess'];
			mysql_free_result($result);

			if (!empty($boards))
			{
				db_query("
					DELETE FROM {$db_prefix}chess
					WHERE id_chess IN (" . implode(', ', $boards) . ")", __FILE__, __LINE__);
				$affected_total += db_affected_rows();
				
				db_query("
					DELETE FROM {$db_prefix}chess_chat
					WHERE id_chess IN (" . implode(', ', $boards) . ")", __FILE__, __LINE__);
				
				db_query("
					DELETE FROM {$db_prefix}chess_move
					WHERE id_chess IN (" . implode(', ', $boards) . ")", __FILE__, __LINE__);
			}
					
			$context['SMFChess']['result']['SMFChess_maint_result_fixnull'] = $affected_total;
		}
		
		// Purge Stangnant Games
		elseif($_GET['do'] == 'clean'){
			checkSession('get');
			$boards = array();
				
			if(isset($_POST['clean_stagnant_check'])){
				//Check Inprogress
				$affected_total = 0;
				$result = db_query("
					SELECT id_chess
					FROM {$db_prefix}chess
					WHERE updated < ". (time() - ($_POST['clean_stagnant_mindays']*86400)) ." AND (status BETWEEN 1 AND 2)
					GROUP BY id_chess", __FILE__, __LINE__);
				
				while ($row = mysql_fetch_assoc($result)){
					$boards[] = $row['id_chess'];
					$affected_total++;
				}
				mysql_free_result($result);
				$context['SMFChess']['result']['SMFChess_maint_result_cleanprogress'] = $affected_total ;
				
				//Check Not Started
				$affected_total = 0;
				$result = db_query("
					SELECT id_chess
					FROM {$db_prefix}chess
					WHERE created < ". (time() - ($_POST['clean_stagnant_mindays']*86400)) ." AND (status = 0)
					GROUP BY id_chess", __FILE__, __LINE__);
				
				while ($row = mysql_fetch_assoc($result)){
					$boards[] = $row['id_chess'];
					$affected_total++;
				}
				mysql_free_result($result);
				$context['SMFChess']['result']['SMFChess_maint_result_cleannotstarted'] = $affected_total ;

			}
			if(isset($_POST['clean_finished_check'])){
				//Check Finished
				$affected_total = 0;
				$result = db_query("
					SELECT id_chess
					FROM {$db_prefix}chess
					WHERE updated < ". (time() - ($_POST['clean_finished_mindays']*86400)) ." AND (status > 2)
					GROUP BY id_chess", __FILE__, __LINE__);
				
				while ($row = mysql_fetch_assoc($result)){
					$boards[] = $row['id_chess'];
					$affected_total++;
				}
				mysql_free_result($result);
				$context['SMFChess']['result']['SMFChess_maint_result_cleanfinished'] = $affected_total ;
			}
			
			if (!empty($boards))
			{
				db_query("
					DELETE FROM {$db_prefix}chess
					WHERE id_chess IN (" . implode(', ', $boards) . ")", __FILE__, __LINE__);
				
				db_query("
					DELETE FROM {$db_prefix}chess_chat
					WHERE id_chess IN (" . implode(', ', $boards) . ")", __FILE__, __LINE__);
				
				db_query("
					DELETE FROM {$db_prefix}chess_move
					WHERE id_chess IN (" . implode(', ', $boards) . ")", __FILE__, __LINE__);
			}
		}
		
		// Import PGN
		elseif($_GET['do'] == 'import'){
			if(!isset($_POST['import_msg']))
					$_POST['import_msg'] = '';
			if(!isset($_POST['import_msg_sub']))
					$_POST['import_msg_sub'] = '';
			if(!isset($_POST['import_pgn']))
					$_POST['import_pgn'] = '';
			
			$request = db_query("
					SELECT ID_MEMBER, memberName
					FROM {$db_prefix}members
					WHERE memberName IN ('". $_POST['import_name_white']."', '".$_POST['import_name_black']."') OR realName IN ('". $_POST['import_name_white']."', '".$_POST['import_name_black']."')
					LIMIT 2", __FILE__, __LINE__);
			if(mysql_num_rows($request) == 2){
				$player1 = mysql_fetch_assoc($request);
				$player2 = mysql_fetch_assoc($request);
				mysql_free_result($request);
				
				$whiteId = ($player1['memberName'] == $_POST['import_name_white']) ? $player1['ID_MEMBER'] : $player2['ID_MEMBER'];
				$blackId = ($player1['memberName'] == $_POST['import_name_black']) ? $player1['ID_MEMBER'] : $player2['ID_MEMBER'];
				unset($player1, $player2);
				
				if(empty($_POST['import_pgn'])){
					if($_POST['ImportVariation'] == 3){
						srand(time());
						$fischerArray =  file($settings['default_theme_dir'].'/SMFChess/fischer'.rand(0, 9).'.txt');
						if($fischerArray){
							$keyTemp = array_rand($fischerArray, 1);
							$fenTemp = $fischerArray[$keyTemp];
							unset($fischerArray);
							unset($keyTemp);
							
						}else
							$fenTemp = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq -';
						
					}else
						$fenTemp = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq -';
					
					$_POST['ImportMoveClock'] = (int)$_POST['ImportMoveClock'];
					$_POST['ImportVariation'] = (int)$_POST['ImportVariation'];
					
					db_query("INSERT INTO {$db_prefix}chess SET boarddata='{$fenTemp} 0 1', white='{$whiteId}', black='{$blackId}', status='0', move='0', created='".time()."', updated='".time()."', control='2', extra='{$whiteId}', moveclock='{$_POST['ImportMoveClock']}', variation='{$_POST['ImportVariation']}', movetime = '".time()."'" , __FILE__, __LINE__);
					$importedBoard = db_insert_id();		
					
					//Insert Move
					db_query("INSERT INTO {$db_prefix}chess_move SET id_chess='{$importedBoard}', ID_MEMBER='{$blackId}', move='0', status='0', move_info='---------', boarddata='{$fenTemp} 0 1', turn='b'" , __FILE__, __LINE__);
						
				
				}else{
					$importedBoard = parsePGN($_POST['import_pgn'], $whiteId, $blackId);
				}
				
				//Add rules to msg
				$_POST['import_msg'] = $_POST['import_msg'].'

'.$txt['SMFChess_a_m']['t_i_variant_msg'].': '.$txt['SMFChess_variation'][$_POST['ImportVariation']] .
										($_POST['ImportMoveClock'] ? '
'.$txt['SMFChess_a_m']['t_i_moveclock_msg'].': '.$txt['SMFChess_moveclock'][$_POST['ImportMoveClock']] : '');
				
				chessPM('import', $whiteId, $importedBoard, $_POST['import_msg'], $_POST['import_msg_sub']);
				chessPM('import', $blackId, $importedBoard, $_POST['import_msg'], $_POST['import_msg_sub']);
				
				$context['SMFChess']['result']['SMFChess_maint_import'] = $importedBoard;
			}else{
				mysql_free_result($request);	
				$context['SMFChess']['result']['SMFChess_maint_importfailed'] = $txt['SMFChess_maint_importfailed2'];
			}
		}
	}	
}

// Modified Parse PGN function from SmoothChess as per permission from SmoothChess Author
function parsePGN($pgn, $whiteId, $blackId){
	global $db_prefix;
	$setup	= array('a8'=>'rd','b8'=>'nd','c8'=>'bd','d8'=>'qd','e8'=>'kd','f8'=>'bd','g8'=>'nd','h8'=>'rd','a7'=>'pd','b7'=>'pd','c7'=>'pd','d7'=>'pd','e7'=>'pd','f7'=>'pd','g7'=>'pd','h7'=>'pd','a1'=>'rl','b1'=>'nl','c1'=>'bl','d1'=>'ql','e1'=>'kl','f1'=>'bl','g1'=>'nl','h1'=>'rl','a2'=>'pl','b2'=>'pl','c2'=>'pl','d2'=>'pl','e2'=>'pl','f2'=>'pl','g2'=>'pl','h2'=>'pl'
	,'g3'=>'','e3'=>'','d3'=>'','e6'=>'','c4'=>'','b4'=>'','a4'=>'','b5'=>'','e4'=>'','d5'=>'','a5'=>'','e5'=>''
	,'d4'=>'','a6'=>'','f3'=>'','d4'=>'','h4'=>'','g5'=>'','c5'=>'','g5'=>'','d6'=>'','c0'=>'','e0'=>'','f5'=>''
	,'j7'=>'','j5'=>'','i8'=>'','i4'=>'','d0'=>'','h6'=>'','g6'=>'','f6'=>'','c6'=>'','b6'=>'','h5'=>'','f4'=>''
	,'g4'=>'','a3'=>'','b3'=>'','h3'=>'','c3'=>'');
	
	$castle = array('wK'=>true,'wQ'=>true,'bK'=>true,'bQ'=>true);
	
	$pgn	= trim(str_replace('\r\n',' ',$pgn));
	$pgn	= stripslashes($pgn);
	$result = preg_replace('/[\.\D\S\W]*\[Result "/i','',$pgn);
	$result = preg_replace('/"\][\.\D\S\W]*/','',$result);
	
	$initialFen = preg_replace('/[\.\D\S\W]*\[FEN "/i','',$pgn);
	$initialFen = preg_replace('/"\][\.\D\S\W]*/','',$initialFen);
	if(($initialFen[0] == '[')||empty($initialFen))
		$initialFen = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1';
	
	$setup = initializeBoard($setup, $initialFen);
	if(!$setup)
		return 'Inital Board Failed';

	$moves 	= trim(preg_replace('/\[.*\]/','',$pgn));
	$moves	= preg_split('/\d*\./',$moves);
	
	$playerMovesNum = 2;
	$movesNum = count($moves) - 1;
	$moveCounter = 1;
	$moveArray = array();
	
	for($i=1;$i<=$movesNum;++$i){
		$moveSet 	= explode(' ',$moves[$i]);

		if(isset($moveSet[1]))
			$playerMovesNum = 2;
		else
			$playerMovesNum = 1;
	
		for($x=0;$x<$playerMovesNum;++$x){
			$specific = '';
			$newSpot = '';
			$oldSpot = '';
			if(!in_array(trim($moveSet[$x]), array('0-1','1-0','1/2-1/2','*'))){
				$move = $moveSet[$x];			
				$pieceColor = ($x == 0)? 'l' : 'd';
				$moveColor 	= ($x == 0)? 'w' : 'b';
				$memId 	= ($x == 0)? $whiteId : $blackId;
				
				$move = trim($move);
				
				if(strpos($move,'K') !== false){
				//--king movement
					$piece 						= 'k'.$pieceColor;
					$oldSQ						= array_search($piece,$setup);
					$setup[$oldSQ] 				= null;
					$newSpot = substr($move,-2);
					$setup[$newSpot[0].$newSpot[1]] = $piece;
				}elseif(substr($move,0,5) === 'O-O-O'){
				//--queenside castle movement, check for queenside first because it would also validate at a kingside (castle because of substr)
					$piece 	= 'k'.$pieceColor;
					if($pieceColor == 'd'){
						$setup['e8'] = null;
						$setup['a8'] = null;
						$setup['d8'] = 'rd';
						$setup['c8'] = $piece;
						$castle['bQ'] = false;
					}else{
						$setup['e1'] = null;
						$setup['a1'] = null;
						$setup['d1'] = 'rl';
						$setup['c1'] = $piece;
						$castle['wQ'] = false;
					}
				}elseif(substr($move,0,3) === 'O-O'){
				//--kingside castle movement
					$piece 	= 'k'.$pieceColor;
					if($pieceColor == 'd'){
						$setup['e8'] = null;
						$setup['h8'] = null;
						$setup['f8'] = 'rd';
						$setup['g8'] = $piece;
						$castle['bK'] = false;
					}else{
						$setup['e1'] = null;
						$setup['h1'] = null;
						$setup['f1'] = 'rl';
						$setup['g1'] = $piece;
						$castle['wK'] = false;
					}
				}elseif(strpos($move,'Q') !== false && strpos($move,'=') == false){
				//--queen movement
					$piece = 'q'.$pieceColor;
					$oldSQ				= array_search($piece,$setup);
					$setup[$oldSQ] 		= null;
					$newSpot			= str_replace('+','',$move);
					$newSpot			= str_replace('#','',$newSpot);
					$newSpot			= substr($newSpot,-2);
					$setup[$newSpot[0].$newSpot[1]]	= $piece;
				}elseif(strpos($move,'B') !== false && strpos($move,'=') == false){
				//--bishop movement
					$piece = 'b'.$pieceColor;			
					$newSpot	= str_replace('+','',$move);
					$newSpot	= str_replace('#','',$newSpot);
					$newSpot	= str_replace('x','',$newSpot);	
					if(strlen($newSpot)>3) $specific = $newSpot{1};
					$newSpot	= substr($newSpot,-2);
					$pieceArray	= array_keys($setup,$piece);
					$arrayCount	= count($pieceArray);				
					for($n=0;$n<$arrayCount;++$n){
						$square	= $pieceArray[$n];
						if($specific){
							if($square{0} == $specific || $square{1} == $specific) $oldSpot	= $square;
						}elseif(!$oldSpot){
							if(abs(ord($newSpot{0})-ord($square{0})) == abs($newSpot{1}-$square{1})){
								if($newSpot{0} > $square{0} && $newSpot{1} > $square{1}){
									$gapSize = abs($newSpot{1} - $square{1});
									$direc	 = 'ur';
								}elseif($newSpot{0} < $square{0} && $newSpot{1} < $square{1}){
									$gapSize = abs($newSpot{1} - $square{1});
									$direc	 = 'dl';								
								}elseif($newSpot{0} > $square{0} && $newSpot{1} < $square{1}){
									$gapSize = abs($newSpot{1} - $square{1});
									$direc	 = 'dr';								
								}elseif($newSpot{0} < $square{0} && $newSpot{1} > $square{1}){
									$gapSize = abs($newSpot{1} - $square{1});
									$direc	 = 'ul';								
								}
								$blocked = '';
								for($r=1;$r<$gapSize;++$r){
									if($direc == 'ur'){
										$lookSq	= chr(ord($newSpot{0})-$r).($newSpot{1}-$r);
									}elseif($direc == 'dl'){
										$lookSq	= chr(ord($newSpot{0})+$r).($newSpot{1}+$r);
									}elseif($direc == 'dr'){
										$lookSq	= chr(ord($newSpot{0})-$r).($newSpot{1}+$r);
									}elseif($direc == 'ul'){
										$lookSq	= chr(ord($newSpot{0})+$r).($newSpot{1}-$r);
									}
									if($setup[$lookSq] != '') $blocked = true;
								}
								if(!$blocked) $oldSpot = $square;
							}
						}
					}	
					$setup[$newSpot[0].$newSpot[1]]	= $piece;
					$setup[$oldSpot]	= null;
				}elseif(strpos($move,'N') !== false && strpos($move,'=') == false){
				//--knight movement
					$piece = 'n'.$pieceColor;
					
					$newSpot	= str_replace('+','',$move);
					$newSpot	= str_replace('#','',$newSpot);
					$newSpot	= str_replace('x','',$newSpot);	
					
					if(strlen($newSpot)>3) $specific = $newSpot{1};
					$newSpot	= substr($newSpot,-2);	
											
					$posArray[0]	= chr(ord($newSpot{0}) - 2).($newSpot{1} + 1);
					$posArray[1]	= chr(ord($newSpot{0}) - 2).($newSpot{1} - 1);
					$posArray[2]	= chr(ord($newSpot{0}) + 2).($newSpot{1} + 1);
					$posArray[3]	= chr(ord($newSpot{0}) + 2).($newSpot{1} - 1);
					$posArray[4]	= chr(ord($newSpot{0}) - 1).($newSpot{1} + 2);
					$posArray[5]	= chr(ord($newSpot{0}) - 1).($newSpot{1} - 2);
					$posArray[6]	= chr(ord($newSpot{0}) + 1).($newSpot{1} + 2);
					$posArray[7]	= chr(ord($newSpot{0}) + 1).($newSpot{1} - 2);
					for($n=0;$n<8;++$n){
							$square 	= $posArray[$n];
						if(isset($setup[$square])){
							$spotPiece	= $setup[$square];
							if($spotPiece == $piece){
								if($specific){
									if(strpos($square, $specific) !== false) $oldSpot = $square;
								}else{
									$oldSpot = $square;
								}
							}
						}
					}
					$setup[$newSpot]	= $piece;
					$setup[$oldSpot]	= null;
				}elseif(strpos($move,'R') !== false && strpos($move,'=') == false){
				//--rook movement
					$piece = 'r'.$pieceColor;
					$newSpot	= str_replace('+','',$move);
					$newSpot	= str_replace('#','',$newSpot);
					$newSpot	= str_replace('x','',$newSpot);	
					if(strlen($newSpot)>3) $specific = $newSpot{1};
					$newSpot	= substr($newSpot,-2);
					$pieceArray	= array_keys($setup,$piece);
					$arrayCount	= count($pieceArray);
					for($n=0;$n<$arrayCount;++$n){
						$square	= $pieceArray[$n];
						if($square{0} == $newSpot{0} || $square{1} == $newSpot{1}){
							if($specific){
								if($square{0} == $specific || $square{1} == $specific) $oldSpot	= $square;
							}elseif(!$oldSpot){
								if($newSpot{0} == $square{0}){
									$gap 	 = $newSpot{1} - $square{1};
									$gapSize = abs($gap);
									$direc	 = 'file';
								}else{
									$gap 	 = ord($newSpot{0}) - ord($square{0});
									$gapSize = abs($gap);
									$direc	 = 'row';								
								}
								$blocked = '';
								for($r=1;$r<$gapSize;++$r){
									if($direc == 'file'){
										if($gap<0){
											$lookSq	= $newSpot{0}.($newSpot{1}+$r);
										}else{
											$lookSq	= $newSpot{0}.($newSpot{1}-$r);
										}
									}else{
										if($gap<0){
											$lookSq	= chr(ord($newSpot{0})+$r).$newSpot{1};
										}else{
											$lookSq	= chr(ord($newSpot{0})-$r).$newSpot{1};
										}
									}
									if($setup[$lookSq] != '') $blocked = true;
								}
								if(!$blocked) $oldSpot	= $square;
							}
						}
					}	
					$setup[$newSpot[0].$newSpot[1]]	= $piece;
					$setup[$oldSpot]	= null;
					
					//White Castle
					if($oldSpot[1] == 1){
						//White Queenside
						if($oldSpot[0] == 'a')
							$castle['wQ'] = false;
						//White Kingside
						if($oldSpot[0] == 'h')
							$castle['wK'] = false;
							
					}if($oldSpot[1] == 8){
						//White Queenside
						if($oldSpot[0] == 'a')
							$castle['bQ'] = false;
						//White Kingside
						if($oldSpot[0] == 'h')
							$castle['bK'] = false;
					}
				}elseif(in_array($move, array('0-1','1-0','1/2-1/2','*'))){
				}elseif($move){
				//-- pawn movement
					$piece 		= 'p'.$pieceColor;				
					if(strpos($move,'x')){
						if($pieceColor == 'l'){
							$setup[$move{2}.$move{3}]		= $piece;
							$setup[$move{0}.($move{3}-1)]	= null;
							$spot							= $move{0}.($move{3}-1);
						}else{
							$setup[$move{2}.$move{3}]		= $piece;
							$setup[$move{0}.($move{3}+1)]	= null;
							$spot							= $move{0}.($move{3}+1);
						}
						if(strpos($move,'=')){
							$setup[$spot]		= null;
							$setup[$move{2}.$move{3}]		= strtolower($move{5}.$pieceColor);
						}
					}else{
						$move	= preg_replace('/[+#]*/','',$move);					
						if($pieceColor == 'l'){
							$square	= $move{0}.($move{1}-1);
							if($setup[$square] == $piece){
								$oldSpot	= $square;
							}else{
								$oldSpot	= $move{0}.($move{1}-2);				
							}
						}else{
							$square	= $move{0}.($move{1}+1);
							
							if($setup[$square] == $piece){
								$oldSpot	= $square;
							}else{
								$oldSpot	= $move{0}.($move{1}+2);
							}
						}
						
						if(strpos($move,'=')){
							$setup[$move{0}.$move{1}]	= strtolower($move{3}).$pieceColor;
						}else{
							$setup[$move[0].$move[1]] 	= $piece;
						}
						$setup[$oldSpot]	= null;
					}
				}	
				if(preg_match('/[+]/', $move)){
					if($pieceColor == 'l'){
						$castle['bK'] = false;
						$castle['bQ'] = false;
					}
					else{
						$castle['wK'] = false;
						$castle['wQ'] = false;
					}
				}
				if(preg_match('/[+]/', $move))
					$moveStatus = 2;
				elseif(preg_match('/[#]/', $move))
					$moveStatus = 3;
				else
					$moveStatus = 1;
				$moveArray[] = array('moveInfo' => $move, 'turn' => $moveColor, 'move' => $moveCounter, 'boarddata' => makeFen($setup, $castle, $moveCounter, $moveColor), 'status' => $moveStatus, 'memId' => $memId);
				if($moveColor == 'b')
					$moveCounter++;
			}
		}
	}

	$moveColor = ($moveColor == 'w') ? 'b' : 'w';
	
	if(($result == '1-0')||($result == '0-1')){
		if(preg_match('/[#]/', $move))
			$status = 3;
		else
			$status = 5;
		$extra = ($result == '1-0') ? $whiteId : $blackId;
		
	}
	elseif($result == '1/2-1/2'){
		$status = 4;
		$extra = 0;
	}
	else{
		if(preg_match('/[+]/', $move)){
			$status = 2;
			$extra = ($moveColor == 'w') ? $whiteId : $blackId;
		}
		elseif(preg_match('/[#]/', $move)){
			$status = 3;
			$extra = ($moveColor == 'w') ? $blackId : $whiteId;
		}
		else{
			$status = 1;
			$extra = ($moveColor == 'w') ? $whiteId : $blackId;
		}
	}

	if($status == 3)
		$castle = array('wK'=>false,'wQ'=>false,'bK'=>false,'bQ'=>false);

	$setup = makeFen($setup, $castle, $movesNum, $moveColor);
	
	db_query("INSERT INTO {$db_prefix}chess SET boarddata='{$setup}', white='{$whiteId}', black='{$blackId}', status='{$status}', move='{$movesNum}', created='".time()."', updated='".time()."', control='0', extra='{$extra}', moveclock='{$_POST['ImportMoveClock']}', movetime = '".time()."'" , __FILE__, __LINE__);
	$newId = db_insert_id();

	$pgnInsert = "($newId, {$blackId}, 0, 0, '---------', '{$initialFen}', 'b'),";
	$moveArray[count($moveArray)-1]['status'] = $status;
	foreach($moveArray as $pgnMove){
		$pgnInsert .=  "
		($newId, {$pgnMove['memId']}, {$pgnMove['move']}, {$pgnMove['status']}, '{$pgnMove['moveInfo']}', '{$pgnMove['boarddata']}', '{$pgnMove['turn']}'),";
	}
	$pgnInsert = substr($pgnInsert,0,-1);
	
	db_query("INSERT INTO {$db_prefix}chess_move
		(id_chess, id_member, move, status, move_info, boarddata, turn)
	VALUES$pgnInsert" , __FILE__, __LINE__);

	return $newId;
}

//makeFen from resulting PGN import
function makeFen($Board, $castle, $moves, $turn)
{
	$s = "";
	$i = 56;
	$p = 8;
	while ($i > -1) {
	
			$j = 'a';
			$l = 0;
			$f = "";
			while ($j <= 'h') {
					switch ($Board[$j.$p]) {
							case 'kl': $f = "K"; break;
							case 'ql': $f = "Q"; break;
							case 'rl': $f = "R"; break;
							case 'bl': $f = "B"; break;
							case 'nl': $f = "N"; break;
							case 'pl': $f = "P"; break;
							case 'kd': $f = "k"; break;
							case 'qd': $f = "q"; break;
							case 'rd': $f = "r"; break;
							case 'bd': $f = "b"; break;
							case 'nd': $f = "n"; break;
							case 'pd': $f = "p"; break;
							
							default: $l++;
					}
					if (($f != "") || ($j == 'h')) {
							if ($l > 0) {
									$s = $s . $l;
									$l = 0;
							}
							$s = $s . $f;
							$f = "";
					}
					$j++;
			}
			$i = $i - 8;
			$p--;
			if ($i > -1)
					$s = $s . "/";
	}
	
	$s = $s.' '.$turn.' ';
	$r = '';
	if ($castle['wK']) $r = $r . "K";
	if ($castle['wQ']) $r = $r . "Q";
	if ($castle['bK']) $r = $r . "k";
	if ($castle['bQ']) $r = $r . "q";
	
	if ($r == "")
			$r = "-";
	$s = $s . $r;
	
	$s = $s. ' 0 '.$moves;
	
	return $s;
}

//Im really not sure i forgot what this does
//Returns something for the board
function initializeBoard($setup, $board)
{
	$board = explode(' ', $board);
	$board = $board[0];
	$board = explode('/', $board);
	if(count($board) != 8)
		return false;
	$board = array_reverse($board);
	$temp = '';
	$colNum = 1;
	$Board = array();
	foreach($board as $row){
		$board2 = str_split($row);
		$rowNum = 'a';
		foreach($board2 as $col){
			$i=0;
			switch ($col) {
                        case "K": $temp = 'kl'; break;
                        case "Q": $temp = 'ql'; break;
                        case "R": $temp = 'rl'; break;
                        case "B": $temp = 'bl'; break;
                        case "N": $temp = 'nl'; break;
                        case "P": $temp = 'pl'; break;
                        case "k": $temp = 'kd'; break;
                        case "q": $temp = 'qd'; break;
                        case "r": $temp = 'rd'; break;
                        case "b": $temp = 'bd'; break;
                        case "n": $temp = 'nd'; break;
                        case "p": $temp = 'pd'; break;

                        case "1": $i = 1; break;
                        case "2": $i = 2; break;
                        case "3": $i = 3; break;
                        case "4": $i = 4; break;
                        case "5": $i = 5; break;
                        case "6": $i = 6; break;
                        case "7": $i = 7; break;
                        case "8": $i = 8; break;
						default : return false;
			}
			if($i > 0){
				while($i > 0){
					$setup[$rowNum.$colNum] = '';
					$i--;
				}
			}else{
				$setup[$rowNum.$colNum] = $temp;
			}
			$rowNum++;
		}
		$colNum++;
	}
	
	return $setup;
}

//Php5 function for those php4 users
if(!function_exists('str_split')){
	function str_split($text, $split = 1){
		$array = array();
		for ($i = 0; $i < strlen($text);){
			$array[] = substr($text, $i, $split);
			$i += $split;
		}
		return $array;
	}
}

//Handles PM's
function chessPM($type, $sendId, $boardId, $pmMsg = '', $pmSub = '')
{
	global $scripturl, $context, $sourcedir, $settings, $func, $txt;
	
	include_once($sourcedir . '/Subs-Post.php');
	
	if(in_array($type, array('import'))){
		// Who the IM will come from		 
		$pmfrom = array(
			'id' => $context['user']['id'],
			'name' => $context['user']['name'],
			'username' => $context['user']['username']
		);
		
		// Who the IM is going to
		$pmto = array(
			'to' => array($sendId),
			'bcc' => array()
		);
		
		$pmMsg = $func['htmlspecialchars']($pmMsg, ENT_QUOTES);
		$pmSub = $func['htmlspecialchars']($pmSub, ENT_QUOTES);							
		
		// The actual message contents
		$message = (!empty($pmMsg)?$pmMsg.'
':'').$txt['SMFChess_pm']['followlink'].$scripturl.'?action=chess;id='.$boardId;
		// Now, send!
		sendpm($pmto, $pmSub, $message, 0, $pmfrom);
	}
}
?>
