<?php

//ChessChat Source File
//ChessChat.php

function ChessChat()
{
	global $modSettings, $context;

	loadTemplate('ChessChat');
		
	$context['SMFChessChat'] = array();
	
	if($modSettings['SMFChessChat_enabled'])
	{
		if(!isset($_GET['id']))
			$_GET['id'] = 0;
		
		if(!isset($_GET['chatTotal']))
			$_GET['chatTotal'] = 0;
		
		$_GET['id'] = (int) $_GET['id'];
		$_GET['chatTotal'] = (int) $_GET['chatTotal'];
		
		$actions = array(
			'refresh' => 'SMFChessChatRefresh',
			'save' => 'SMFChessChatSave'
		);
		
		if (!isset($_GET['sa']))
			$action = 'refresh';
		else
			$action = $_GET['sa'];
		
		if(isset($actions[$action]))
			$actions[$action]();
		else
			SMFChessChatRefresh();
	}
}

//Process Commands
function processCommand($msgString)
{
	global $context;
	$msgExplode = explode(' ',$msgString,2);
	switch($msgExplode[0])
	{
		case "/me":
			$context['SMFChessChat']['hideName'] = true;
			return '* '.$context['user']['name'].' '.$msgExplode[1];
		case "/french":
			return stringTranslate($msgExplode[1], 'en|fr');
		case "/italian":
			return stringTranslate($msgExplode[1], 'en|it');
		case "/portuguese":
			return stringTranslate($msgExplode[1], 'en|pt');
		default:
			return $msgExplode[1];
	}
}

//Translate a string, a silly google translate query
function stringTranslate($msgString, $lang)
{
	$stringTrans = urlencode($msgString);
	
	$in = @file_get_contents("http://google.com/translate_t?langpair=".$lang."&text=".$stringTrans."") or false;
	if($in){
		preg_match('/<div id=result_box dir=ltr>(.*?)<\/div>/', $in, $out);
		return $out[1];
	}else{
		return $msgString;
	}
}

// Modified ssi_whosOnlines
function whosWatching($boardId)
{
	global $scripturl, $db_prefix, $context;
	
	$timeAgo = time() - 20;
	
	// Load the users online right now.
	$result = db_query("
		SELECT
			lo.ID_MEMBER, lo.logTime, mem.realName, mem.memberName, mem.showOnline,
			mg.onlineColor, mg.ID_GROUP
		FROM {$db_prefix}log_online AS lo
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = lo.ID_MEMBER)
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = IF(mem.ID_GROUP = 0, mem.ID_POST_GROUP, mem.ID_GROUP))
		WHERE lo.url LIKE '%chess%' AND lo.url LIKE '%\"id\";s:%:\"{$boardId}\"%' AND (UNIX_TIMESTAMP(lo.logTime) > " . (time() - 20) . ")
		ORDER BY mem.memberName", __FILE__, __LINE__);

	$return['users'] = array();
	$context['allow_chess_admin'] = allowedTo('chess_admin');
	
	while ($row = mysql_fetch_assoc($result))
	{
		if (!empty($row['showOnline']) || $context['allow_chess_admin'])
		{
			if (!empty($row['onlineColor']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '" style="color: ' . $row['onlineColor'] . ';">' . $row['realName'] . '</a>';
			else
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>';
			$return['users'][$row['logTime'] . $row['memberName']] = array(
				'id' => $row['ID_MEMBER'],
				'username' => $row['memberName'],
				'name' => $row['realName'],
				'group' => $row['ID_GROUP'],
				'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
				'link' => $link,
				'hidden' => empty($row['showOnline']),
				'is_last' => false,
			);
		}
	}
	mysql_free_result($result);

	if (!empty($return['users'])){
		$userlist = array_keys($return['users']);
		$return['users'][$userlist[count($userlist) - 1]]['is_last'] = true;
	}
	return $return;
}

//Trys to get a refresh of the chat
function SMFChessChatRefresh()
{
	global $options, $modSettings, $context, $db_prefix, $sourcedir, $settings, $scripturl;
	
	loadLanguage('ChessXml');
	
	if(!isset($options['SMFChess_log']))
		$options['SMFChess_log'] = $modSettings['SMFChessChat_log'];
	
	if(isset($_GET['showChat'])){
		if(empty($_GET['showChat']) || !in_array($_GET['showChat'], array('all', 'both', 'chat', 'log')))
			$_GET['showChat'] = 'both';
		if($_GET['showChat'] == 'both')
			$options['SMFChess_log'] = 2;
		elseif($_GET['showChat'] == 'chat')
			$options['SMFChess_log'] = 0;
		elseif($_GET['showChat'] == 'log')
			$options['SMFChess_log'] = 1;
		
		if(!$context['user']['is_guest']){	
			$_POST['options']['SMFChess_log'] = $options['SMFChess_log'];
			include_once($sourcedir . '/Profile.php');
			makeThemeChanges($context['user']['id'], $settings['theme_id']);
		}
			
	}else
		$_GET['showChat'] = 'both';
					
	$context['SMFChessChat']['whosWatching'] = whosWatching($_GET['id']);
	
	$result = db_query("
		SELECT status, variation
		FROM {$db_prefix}chess
		WHERE id_chess = '{$_GET['id']}'
		LIMIT 1
		", __FILE__, __LINE__);
	list($context['SMFChessChat']['status'], $context['SMFChessChat']['variation']) = mysql_fetch_row($result);
	mysql_free_result($result);
	if(($context['SMFChessChat']['variation'] == 1)&&($context['SMFChessChat']['status'] < 2))
		$options['SMFChess_log'] = 0;
					
	$result = db_query("
		SELECT chat.id_chess
		FROM {$db_prefix}chess_chat as chat
		JOIN {$db_prefix}members AS mem ON (chat.id_member = mem.ID_MEMBER)
		WHERE chat.id_chess = '{$_GET['id']}'".($options['SMFChess_log'] == 2 ? "" : " AND chat.type = '{$options['SMFChess_log']}'")."
		", __FILE__, __LINE__);
	$context['SMFChessChat']['numChat'] = mysql_num_rows($result);
	mysql_free_result($result);
			
	$context['SMFChessChat']['chat'] = array();
	$context['SMFChessChat']['firstTime'] = false;

	if($context['SMFChessChat']['numChat'] == 0){
		$context['SMFChessChat']['chat'][] = '';
		if($context['SMFChessChat']['numChat'] != $_GET['chatTotal'])
			$context['SMFChessChat']['firstTime'] = true;
	}elseif($_GET['chatTotal'] == $context['SMFChessChat']['numChat']){
		$context['SMFChessChat']['chat'][] = '';
	}else{
		$result = db_query("
		SELECT chat.*, mem.realName, mem.avatar, IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType
		FROM {$db_prefix}chess_chat as chat
		JOIN {$db_prefix}members AS mem ON (chat.id_member = mem.ID_MEMBER)
		LEFT JOIN {$db_prefix}attachments AS a ON (a.ID_MEMBER = mem.ID_MEMBER)
		WHERE chat.id_chess = '{$_GET['id']}'".(($options['SMFChess_log'] == 2) || ($_GET['showChat'] == 'all' )? "" : " AND chat.type = '{$options['SMFChess_log']}'")."
		ORDER BY id_chat DESC
		".($_GET['showChat'] == 'all' ?"":"LIMIT 10")."
		", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($result)){
			$row += array(
				'image' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" width="32" height="32" alt="" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" width="32" height="32" alt="" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" width="32" height="32" alt="" border="0" />')
		);
			$context['SMFChessChat']['chat'][] = $row;
		}
		
		mysql_free_result($result);
	}
	
	$context['sub_template'] = 'ChessChatRefresh';
}

//Saves the chat, if it can
function SMFChessChatSave()
{
	global $context, $scripturl, $db_prefix, $modSettings;	
	
	$context['SMFChessChat']['Text'] = '';
			
	$result = db_query("
		SELECT chess.id_chess, chess.white, chess.black
		FROM {$db_prefix}chess AS chess
		WHERE chess.id_chess = '{$_GET['id']}'
		LIMIT 1
		", __FILE__, __LINE__);
			
	if(mysql_num_rows($result) == 0)
		mysql_free_result($result);
	else{
		$context['SMFChessChat']['hideName'] = false;
		$temp = mysql_fetch_assoc($result);
		mysql_free_result($result);

		if(isset($_POST['message'])){
			if($modSettings['SMFChessChat_who'] == 1)
				$allowMsg = !$context['user']['is_guest'];
			elseif($modSettings['SMFChessChat_who'] == 2)
				$allowMsg = ($temp['white'] == $context['user']['id'])||($temp['black'] == $context['user']['id'])||allowedTo('chess_admin');
			else
				$allowMsg = false;
					
			if($allowMsg){
				global $sourcedir, $func;

				require_once($sourcedir . '/Subs-Post.php');
					
				if ($func['htmltrim']($_POST['message']) === ''){}
				else{
					$_POST['message'] = $func['htmlspecialchars']($_POST['message'], ENT_QUOTES);
					if($_POST['message'][0] == '/')
						$_POST['message'] = processCommand($_POST['message']);
							
					$_POST['message'] = str_replace(array("[list]","[center]","[left]","[right]"),"",$_POST['message']);
					preparsecode($_POST['message']);
					$_POST['message'] = parse_bbc($_POST['message']);
					censorText($_POST['message']);
							
					$context['SMFChessChat']['Text'] = $_POST['message'];
					
					db_query("INSERT INTO {$db_prefix}chess_chat 
							SET id_chess='{$temp['id_chess']}',  timestamp='".time()."', 
							text='{$_POST['message']}', id_member='{$context['user']['id']}'" , __FILE__, __LINE__);			
				}
			}
		}elseif(isset($_POST['deleteMsg']) && allowedTo('chess_admin')){
			$_POST['deleteMsg'] = (int) $_POST['deleteMsg'];
			$context['SMFChessChat']['Text'] = 'deleted';
					
			db_query("DELETE FROM {$db_prefix}chess_chat
				WHERE id_chat = {$_POST['deleteMsg']} AND id_chess='{$temp['id_chess']}'
				LIMIT 1", __FILE__, __LINE__);	
		}
	}
			
	$context['sub_template'] = 'ChessChatSave';
}
?>