/* 
	Javascript File for SMFChess Admin Settings
*/

window.onload = function(){
	["light", "dark", "border", "text", "highlight"].each(function(idx) {
	  new Control.ColorPicker("SMFChess_" + idx, { IMAGE_BASE : smfchessUrl + "colorpicker/img/"});
	});
	piecePreview(currentPiece);
}

function do_PieceChange(temp)
{
	temp2 = temp.value;
	if(temp2 == "")
		temp2 = currentPiece;
	
	piecePreview(temp2);
	
}

function do_SizeChange(temp)
{
	temp2 = temp.value;
	if(temp2 == "0"){
		temp2 = actualPrevImageSize;
	}
	
	document.getElementById('previmage').height = temp2;
	document.getElementById('previmage').width = temp2;
	
}

function do_EffectChange(temp)
{
	temp2 = temp.value;
	//Highlight
	if(temp2 == 1){
		new Effect.Highlight(document.getElementById('previmage'), {startcolor: "#" + startcolor , endcolor: "#" + endcolor});
	}
	//Shake
	else if(temp2 == 2){
		new Effect.Shake(document.getElementById('previmage'), {distance:2});
	}
	//Pulse
	else if(temp2 == 3){
		new Effect.Pulsate(document.getElementById('previmage'), {pulses: 2, from: 0.2, duration: 1});
	}
	
}

function piecePreview(getpiece){
	
	if (!window.XMLHttpRequest)
		return;
	if (typeof(window.opera) != "undefined")
	{
		var test = new XMLHttpRequest();
		if (typeof(test.setRequestHeader) != "function")
			return;
	}
	
	setInnerHTML(document.getElementById('piecePrevDiv'), "<img src='" + smfchessUrl + "images/loading.gif'/>");
	
	getXMLDocument(smf_scripturl + "?action=chessXml;sa=pieceViewer;sesc=" + cur_session_id + ";getpiece=" + getpiece + ";xml", onDocReceived_piecePreview);

	return false;
}

function onDocReceived_piecePreview(XMLDoc)
{
	if (!XMLDoc)
	{
		setInnerHTML(document.getElementById('boardPreviewDiv' + cur_boardId), "?");
	}
	
	var cur_pieceInfo = XMLDoc.getElementsByTagName("info")[0].childNodes[0].nodeValue;
	actualPrevImageSize = XMLDoc.getElementsByTagName("imagesize")[0].childNodes[0].nodeValue;
	
	setInnerHTML(document.getElementById('piecePrevDiv'), cur_pieceInfo);
}

function suggestColor(size){

	switch(size){
		case 5:	document.SMFChess_admin.SMFChess_highlight.value = document.getElementById('SC_4').title;
				document.SMFChess_admin.SMFChess_highlight.style.backgroundColor = "#" + document.getElementById('SC_4').title;
		case 4:	document.SMFChess_admin.SMFChess_text.value = document.getElementById('SC_3').title;
				document.SMFChess_admin.SMFChess_text.style.backgroundColor = "#" + document.getElementById('SC_3').title;
		case 3:	document.SMFChess_admin.SMFChess_border.value = document.getElementById('SC_2').title;
				document.SMFChess_admin.SMFChess_border.style.backgroundColor = "#" + document.getElementById('SC_2').title;
		case 2:	document.SMFChess_admin.SMFChess_dark.value = document.getElementById('SC_1').title;
				document.SMFChess_admin.SMFChess_dark.style.backgroundColor = "#" + document.getElementById('SC_1').title;
		case 1:	document.SMFChess_admin.SMFChess_light.value = document.getElementById('SC_0').title;
				document.SMFChess_admin.SMFChess_light.style.backgroundColor = "#" + document.getElementById('SC_0').title;
	}
}